// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

// tslint:disable
/**
 * eGesetzgebung Platform
 * This is the rest interface offered by the eGesetzgebung Platform backend.  Please provide __JW Access Token__ using button \'Authorize\' to access protected endpoints. Use the following instructions to get token:  1. on CMD/Bash/Terminal: ```curl -d \"client_id=user-management\" -d \"client_secret=INSERT_IAM_SECRET\" -d \"grant_type=password&username=INSERT_USER_EMAIL&password=INSERT_USER_PASSWORD\" \"INSERT_IAM_URL/realms/bund/protocol/openid-connect/token\"``` 2. copy access_token (without quotes, you can use jq or other tools to extract this value automatically) 3. insert value into \'JWToken\' field under \'Authorize\' and press \'Authorize\' 4. now you should have access to user protected endpoint  __FYI:__ token expires after 60 seconds. On non-production systems only a warning is displayed so you can work smoothly, but on production systems you have to frequently provide a new token.
 *
 * The version of the OpenAPI document: 9.0.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import type { Observable } from 'rxjs';
import type { AjaxResponse } from 'rxjs/ajax';
import { BaseAPI, throwIfNullOrUndefined } from '../runtime';
import type { OperationOpts, HttpHeaders, HttpQuery } from '../runtime';
import type {
    AktionType,
    PermissionsResultDTO,
    RessourceType,
    RolleLokalType,
} from '../models';

export interface GetPermissionsRequest {
    optionType: GetPermissionsOptionTypeEnum;
    benutzer?: Array<string>;
    aktionen?: Array<AktionType>;
    ressourceTypen?: Array<RessourceType>;
    ressourcenIds?: Array<string>;
    rollen?: Array<RolleLokalType>;
}

/**
 * no description
 */
export class RbacControllerApi extends BaseAPI {

    /**
     * lädt die Regeln aus RBAC im CSV-Format
     */
    getCsvRegeln(): Observable<string>
    getCsvRegeln(opts?: OperationOpts): Observable<AjaxResponse<string>>
    getCsvRegeln(opts?: OperationOpts): Observable<string | AjaxResponse<string>> {
        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<string>({
            url: '/rbac/regeln',
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * fragt die Liste der Berechtigungen in RBAC ab
     */
    getPermissions({ optionType, benutzer, aktionen, ressourceTypen, ressourcenIds, rollen }: GetPermissionsRequest): Observable<PermissionsResultDTO>
    getPermissions({ optionType, benutzer, aktionen, ressourceTypen, ressourcenIds, rollen }: GetPermissionsRequest, opts?: OperationOpts): Observable<AjaxResponse<PermissionsResultDTO>>
    getPermissions({ optionType, benutzer, aktionen, ressourceTypen, ressourcenIds, rollen }: GetPermissionsRequest, opts?: OperationOpts): Observable<PermissionsResultDTO | AjaxResponse<PermissionsResultDTO>> {
        throwIfNullOrUndefined(optionType, 'optionType', 'getPermissions');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        const query: HttpQuery = { // required parameters are used directly since they are already checked by throwIfNullOrUndefined
            'optionType': optionType,
        };

        if (benutzer != null) { query['benutzer'] = benutzer; }
        if (aktionen != null) { query['aktionen'] = aktionen; }
        if (ressourceTypen != null) { query['ressourceTypen'] = ressourceTypen; }
        if (ressourcenIds != null) { query['ressourcenIds'] = ressourcenIds; }
        if (rollen != null) { query['rollen'] = rollen; }

        return this.request<PermissionsResultDTO>({
            url: '/rbac/permissions',
            method: 'GET',
            headers,
            query,
        }, opts?.responseOpts);
    };

}

/**
 * @export
 * @enum {string}
 */
export enum GetPermissionsOptionTypeEnum {
    FastNoStatusNoAktionen = 'FAST_NO_STATUS_NO_AKTIONEN',
    SlowCheckStatusGetAktionen = 'SLOW_CHECK_STATUS_GET_AKTIONEN'
}
